//+------------------------------------------------------------------+
//|                                          StepXCCX_HTF_Signal.mq5 | 
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
//|      SmoothAlgorithms.mqh                 |
//|    : __\MQL5\Include  |
//|  : __\MQL5\Indicators      |
//|   ColorStepXCCX                          |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//+----------------------------------------------+ 
//|                  |
//+----------------------------------------------+ 
//----     
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET  0 //        
//+-----------------------------------+    
//|          |
//+-----------------------------------+    
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum APPLIED_PRICE       //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input string Symbol_="";                     //  
input ENUM_TIMEFRAMES Timeframe=PERIOD_H6;   //    
input Smooth_Method DSmoothMethod=MODE_JJMA; //   
input int DPeriod=30;                        //  
input int DPhase=100;                        //  
input Smooth_Method MSmoothMethod=MODE_T3;   //   
input int MPeriod=7;                         //   
input int MPhase=15;                         //   
input APPLIED_PRICE IPC=PRICE_TYPICAL;       //  
input int StepSizeFast=5;                    //  
input int StepSizeSlow=30;                   //  
//----    
input string Symbols_Sirname="StepXCCX_";    //   
input color UpSymbol_Color=Teal;             //   
input color DnSymbol_Color=Magenta;          //   
input color IndName_Color=DarkOrchid;        //   
input uint Symbols_Size=34;                  //   
input uint Font_Size=15;                     //    
input int X_3=120;                           //    
input int Y_3=10;                            //    
input bool ShowIndName=true;                 //   
input ENUM_BASE_CORNER  WhatCorner=CORNER_RIGHT_UPPER; //  
input uint X_=0;                             //   
input uint Y_=0;                             //   
//+-----------------------------------+
//----      
int StepXCCX_Handle;
//----      
int min_rates_total;
//----         
uint X_0,X_1,X_2,X_3_,Yn,Y_3_;
//----     
string name0,name1,name2,name3,IndName,Symb;
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
string GetStringTimeframe(ENUM_TIMEFRAMES timeframe)
  {
//----
   return(StringSubstr(EnumToString(timeframe),7,-1));
//----
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void CreateTLabel(long   chart_id,         //  
                  string name,             //  
                  int    nwin,             //  
                  ENUM_BASE_CORNER corner, //   
                  ENUM_ANCHOR_POINT point, //   
                  int    X,                //      X   
                  int    Y,                //      Y   
                  string text,             // 
                  color  Color,            //  
                  string Font,             //  
                  int    Size)             //  
  {
//----
   ObjectCreate(chart_id,name,OBJ_LABEL,0,0,0);
   ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);
   ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,point);
   ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,X);
   ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,Y);
   ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,Color);
   ObjectSetString(chart_id,name,OBJPROP_FONT,Font);
   ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,Size);
   ObjectSetInteger(chart_id,name,OBJPROP_BACK,true);
//----
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void SetTLabel(long   chart_id,         //  
               string name,             //  
               int    nwin,             //  
               ENUM_BASE_CORNER corner, //   
               ENUM_ANCHOR_POINT point, //   
               int    X,                //      X   
               int    Y,                //      Y   
               string text,             // 
               color  Color,            //  
               string Font,             //  
               int    Size)             //  
  {
//----
   if(ObjectFind(chart_id,name)==-1) CreateTLabel(chart_id,name,nwin,corner,point,X,Y,text,Color,Font,Size);
   else
     {
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,X);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,Y);
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,Color);
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,Size);
     }
//----
  }
//+------------------------------------------------------------------+    
//| StepXCCX indicator initialization function                       | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----    CXMA   SmoothAlgorithms.mqh
   CXMA XMA;
//----     
   min_rates_total=XMA.GetStartBars(DSmoothMethod,DPeriod,DPhase)
                   +XMA.GetStartBars(MSmoothMethod,MPeriod,MPhase)+3;

//----  
   if(Symbol_!="") Symb=Symbol_;
   else Symb=Symbol();

   X_0=X_;
   X_1=uint(X_0+Symbols_Size*1.1);
   X_2=uint(X_1+Symbols_Size*1.1);
   Yn=Y_+5;

   name0=Symbols_Sirname+"0";
   name1=Symbols_Sirname+"1";
   name2=Symbols_Sirname+"2";
   if(ShowIndName)
     {
      Y_3_=Yn+Y_3;
      X_3_=X_0+X_3;
      name3=Symbols_Sirname+"3";
      StringConcatenate(IndName,"StepXCCX(",Symb," ",GetStringTimeframe(Timeframe),")");
     }

//----    StepXCCX
   StepXCCX_Handle=iCustom(Symb,Timeframe,"ColorStepXCCX",DSmoothMethod,DPeriod,DPhase,
                           MSmoothMethod,MPeriod,MPhase,IPC,StepSizeFast,StepSizeSlow,0);
   if(StepXCCX_Handle==INVALID_HANDLE) Print("      ColorStepXCCX");

//----      
   string shortname,SmoothD,SmoothM;
   SmoothD=XMA.GetString_MA_Method(DSmoothMethod);
   SmoothM=XMA.GetString_MA_Method(MSmoothMethod);
   StringConcatenate(shortname,"StepXCCX(",
                     string(DPeriod),",",string(MPeriod),",",SmoothD,",",SmoothM,
                     StepSizeFast,", ",StepSizeSlow,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+
//| StepXCCX deinitialization function                               |
//+------------------------------------------------------------------+    
void Deinit()
  {
//----
   if(ObjectFind(0,name0)!=-1) ObjectDelete(0,name0);
   if(ObjectFind(0,name1)!=-1) ObjectDelete(0,name1);
   if(ObjectFind(0,name2)!=-1) ObjectDelete(0,name2);
   if(ObjectFind(0,name3)!=-1) ObjectDelete(0,name3);
//----
  }
//+------------------------------------------------------------------+
//| StepXCCX deinitialization function                               |
//+------------------------------------------------------------------+    
void OnDeinit(const int reason)
  {
//----
   Deinit();
//----
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+  
//| StepXCCX iteration function                                      | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(StepXCCX_Handle)<min_rates_total) return(RESET);

//----   
   int to_copy=3;
   double dxccx0,dxccx1,dxccx2;
   double XCCX1[3],XCCX2[3];
   color Color0,Color1,Color2;

//----      
   if(CopyBuffer(StepXCCX_Handle,0,0,to_copy,XCCX1)<=0) return(RESET);
   if(CopyBuffer(StepXCCX_Handle,1,0,to_copy,XCCX2)<=0) return(RESET);

   dxccx0=XCCX1[2]-XCCX2[2];
   dxccx1=XCCX1[1]-XCCX2[1];
   dxccx2=XCCX1[0]-XCCX2[0];

   if(dxccx0<0) Color0=DnSymbol_Color; else Color0=UpSymbol_Color;
   if(dxccx1<0) Color1=DnSymbol_Color; else Color1=UpSymbol_Color;
   if(dxccx2<0) Color2=DnSymbol_Color; else Color2=UpSymbol_Color;

   if(ShowIndName)
      SetTLabel(0,name3,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_3_,Y_3_,IndName,IndName_Color,"Georgia",Font_Size);
   SetTLabel(0,name0,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_0,Yn,"l",Color0,"Wingdings",Symbols_Size);
   SetTLabel(0,name1,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_1,Yn,"l",Color1,"Wingdings",Symbols_Size);
   SetTLabel(0,name2,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_2,Yn,"l",Color2,"Wingdings",Symbols_Size);
//----
   ChartRedraw(0);
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
